//
//  TINET (TCP/IP Protocol Stack)
// 
//  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
//                   Tomakomai National College of Technology, JAPAN
//
//  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
//  ˤäƸɽƤ GNU General Public License  Version 2 ˵
//  ҤƤ˸¤ꡤܥեȥܥեȥ
//  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
//  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
//  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
//      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
//      ˴ޤޤƤ뤳ȡ
//  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
//      ѤǤǺۤˤϡۤȼɥȡ
//      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
//      ̵ݾڵǺܤ뤳ȡ
//  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
//      ѤǤʤǺۤˤϡξȡ
//    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
//        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
//  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
//      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
//
//  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
//  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
//  ޤơʤݾڤԤʤޤܥեȥѤˤľ
//  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
// 
//  @(#) $Id: $
//

#ifndef _TINET_CLASSES_H_
#define _TINET_CLASSES_H_

//
// 饹
//

// ѡ

class CoreParser : public ParserComponent {

	private:

	protected:

		// ۴ؿ

		virtual void parseOption (Directory& container);

		// ؿ

		int assignID (Directory& container, const char *category);

	public:

		// 󥹥ȥ饯

		CoreParser (void);

		// ۴ؿ

		virtual bool parse (Parser& parser, Directory& container);

	};

//  TINET ե

class SpecialtyFile : public MultipartStream, public RuntimeObject {

	protected:

		SpecialtyFile (void) throw();

		template<class T>
		static T* createInstance (std::string filename) throw(Exception)
		{
			T* old;
			T* result = 0;

			old = dynamic_cast<T*>(RuntimeObjectTable::getInstance(typeid(T)));
			if (old != 0)
				delete old;

			result = new(nothrow) T;
			if (result == 0)
				ExceptionMessage("Internal error : Object creation failure [createInstance]",
				                 "顼 : ֥顼 [createInstance]") << throwException;
			try {
				result->setFilename(filename);
				}
			catch (...) {
				if (result != 0)
					delete result;
				throw;
				}
			return result;
			};
	};

//  tinet_cfg.c

class TinetCfg : public SpecialtyFile {

	public:

		struct CreationEvent {
			class TinetCfg* file;
			};

		static inline TinetCfg* createInstance (std::string filename) throw(Exception) {
			return SpecialtyFile::createInstance<TinetCfg>(filename);
			};

	};

//  tinet_id.h

class TinetID : public SpecialtyFile {

	public:

		struct CreationEvent {
			class TinetID* file;
			};

		static inline TinetID* createInstance (std::string filename) throw(Exception) {
			return SpecialtyFile::createInstance<TinetID>(filename);
			};

	};

//  tinet_kern.cfg

class TinetKernCfg : public SpecialtyFile {

	public:

		struct CreationEvent {
			class TinetKernCfg* file;
			};

		static inline TinetKernCfg* createInstance (std::string filename) throw(Exception) {
			return SpecialtyFile::createInstance<TinetKernCfg>(filename);
			};

	};

//  ե졼ե

class ConfigurationFileGenerator : public Component {

	private:

		// ؿ

		void outTinet_id_h     (Directory& container);
		void outTinet_cfg_c    (Directory& container);
		void outTinet_kern_cfg (Directory& container);

		void outCfgTCP_CRE_REP (MultipartStream* out, Directory& container);
		void outCfgTCP_CRE_CEP (MultipartStream* out, Directory& container);
		void outCfgUDP_CRE_CEP (MultipartStream* out, Directory& container);

		void outCfgEMPTY_TCP_CRE_REP (MultipartStream* out);

		void outCfgTCP6_CRE_REP (MultipartStream* out, Directory& container);
		void outCfgTCP6_CRE_CEP (MultipartStream* out, Directory& container);
		void outCfgUDP6_CRE_CEP (MultipartStream* out, Directory& container);

		void outKernCfgTCP_CRE_REP (MultipartStream* out, Directory& container);
		void outKernCfgTCP_CRE_CEP (MultipartStream* out, Directory& container);
		void outKernCfgUDP_CRE_CEP (MultipartStream* out, Directory& container);

		void outKernCfgTCP6_CRE_REP (MultipartStream* out, Directory& container);
		void outKernCfgTCP6_CRE_CEP (MultipartStream* out, Directory& container);
		void outKernCfgUDP6_CRE_CEP (MultipartStream* out, Directory& container);

	protected:

		// ۴ؿ

		virtual void parseOption (Directory& container);
		virtual void body        (Directory& container);
		virtual void onFatalExit (Directory& container);

	public:

		// 󥹥ȥ饯

		ConfigurationFileGenerator (void) : Component(CODEGENERATOR) {};

	};

#endif	/* of #ifndef _TINET_CLASSES_H_ */
